> ## Documentation Index
> Fetch the complete documentation index at: https://gcore.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# List virtual GPU cluster servers

> List all servers in a virtual GPU cluster.



## OpenAPI

````yaml /api-reference/services_documented/cloud_api.yaml get /cloud/v3/gpu/virtual/{project_id}/{region_id}/clusters/{cluster_id}/servers
openapi: 3.1.0
info:
  title: Gcore OpenAPI – Cloud API
  description: >-
    This OpenAPI is an aggregated OpenAPI specification that unifies all Gcore
    products into a single file. It covers Cloud, CDN, DNS, WAAP, DDoS
    Protection, Object Storage, Streaming, and FastEdge services.
  version: '2026-05-14T07:00:22.640261+00:00'
servers:
  - url: https://api.gcore.com
security:
  - APIKey: []
tags:
  - name: Bare Metal
    x-displayName: Bare Metal
  - name: Container as a Service
    x-displayName: Container as a Service
  - name: Cost Reports
    x-displayName: Cost Reports
  - name: DDoS Protection
    x-displayName: DDoS Protection
  - name: Everywhere Inference
    x-displayName: Everywhere Inference
  - name: Everywhere Inference Apps
    x-displayName: Everywhere Inference Apps
  - name: File Shares
    x-displayName: File Shares
  - name: Floating IPs
    x-displayName: Floating IPs
  - name: Function as a Service
    x-displayName: Function as a Service
  - name: GPU Bare Metal
    x-displayName: GPU Bare Metal
  - name: GPU Virtual
    x-displayName: GPU Virtual
  - name: IP Ranges
    x-displayName: IP Ranges
  - name: Images
    x-displayName: Images
  - name: Instances
    x-displayName: Instances
  - name: Load Balancers
    x-displayName: Load Balancers
  - name: Logging
    x-displayName: Logging
  - name: Managed Kubernetes
    x-displayName: Managed Kubernetes
  - name: Managed PostgreSQL
    x-displayName: Managed PostgreSQL
  - name: Networks
    x-displayName: Networks
  - name: Placement Groups
    x-displayName: Placement Groups
  - name: Projects
    x-displayName: Projects
  - name: Quotas
    x-displayName: Quotas
  - name: Regions
    x-displayName: Regions
  - name: Registry
    x-displayName: Registry
  - name: Reservations
    x-displayName: Reservations
  - name: Reserved IPs
    x-displayName: Reserved IPs
  - name: Routers
    x-displayName: Routers
  - name: SSH Keys
    x-displayName: SSH Keys
  - name: Secrets
    x-displayName: Secrets
  - name: Security Groups
    x-displayName: Security Groups
  - name: Snapshot Schedules
    x-displayName: Snapshot Schedules
  - name: Snapshots
    x-displayName: Snapshots
  - name: Tasks
    x-displayName: Tasks
  - name: User Actions
    x-displayName: User Actions
  - name: User Role Assignments
    x-displayName: User Role Assignments
  - name: Volumes
    x-displayName: Volumes
paths:
  /cloud/v3/gpu/virtual/{project_id}/{region_id}/clusters/{cluster_id}/servers:
    get:
      tags:
        - GPU Virtual
      summary: List virtual GPU cluster servers
      description: List all servers in a virtual GPU cluster.
      operationId: VirtualClusterInstanceServers.get
      parameters:
        - in: path
          name: project_id
          required: true
          description: Project ID
          schema:
            description: Project ID
            example: 1
            examples:
              - 1
            title: Project Id
            type: integer
        - in: path
          name: region_id
          required: true
          description: Region ID
          schema:
            description: Region ID
            example: 7
            examples:
              - 7
            title: Region Id
            type: integer
        - in: path
          name: cluster_id
          required: true
          description: Cluster unique identifier
          schema:
            description: Cluster unique identifier
            example: 1aaaab48-10d0-46d9-80cc-85209284ceb4
            examples:
              - 1aaaab48-10d0-46d9-80cc-85209284ceb4
            format: uuid4
            title: Cluster Id
            type: string
        - in: query
          name: changed_before
          required: false
          description: >-
            Filters the results to include only servers whose last change
            timestamp is less than the specified datetime. Format: ISO 8601.
          schema:
            description: >-
              Filters the results to include only servers whose last change
              timestamp is less than the specified datetime. Format: ISO 8601.
            example: '2025-10-01T12:00:00Z'
            examples:
              - '2025-10-01T12:00:00Z'
            format: date-time
            title: Changed Before
            type: string
        - in: query
          name: changed_since
          required: false
          description: >-
            Filters the results to include only servers whose last change
            timestamp is greater than or equal to the specified datetime.
            Format: ISO 8601.
          schema:
            description: >-
              Filters the results to include only servers whose last change
              timestamp is greater than or equal to the specified datetime.
              Format: ISO 8601.
            example: '2025-10-01T12:00:00Z'
            examples:
              - '2025-10-01T12:00:00Z'
            format: date-time
            title: Changed Since
            type: string
        - in: query
          name: ip_address
          required: false
          description: Filter servers by ip address.
          schema:
            description: Filter servers by ip address.
            example: 237.84.2.178
            examples:
              - 237.84.2.178
            title: Ip Address
            type: string
        - in: query
          name: limit
          required: false
          description: Limit of items on a single page
          schema:
            default: 10
            description: Limit of items on a single page
            example: 10
            examples:
              - 10
            exclusiveMinimum: 0
            maximum: 1000
            title: Limit
            type: integer
        - in: query
          name: name
          required: false
          description: >-
            Filter servers by name. You can provide a full or partial name,
            servers with matching names will be returned. For example, entering
            'test' will return all servers that contain 'test' in their name.
          schema:
            description: >-
              Filter servers by name. You can provide a full or partial name,
              servers with matching names will be returned. For example,
              entering 'test' will return all servers that contain 'test' in
              their name.
            title: Name
            type: string
        - in: query
          name: offset
          required: false
          description: Offset in results list
          schema:
            default: 0
            description: Offset in results list
            example: 0
            examples:
              - 0
            minimum: 0
            title: Offset
            type: integer
        - in: query
          name: order_by
          required: false
          description: Order field
          schema:
            $ref: '#/components/schemas/GroupOrdering'
            default: created_at.desc
            description: Order field
        - in: query
          name: status
          required: false
          description: Filters servers by status.
          schema:
            $ref: '#/components/schemas/InstanceStatusQuery'
            description: Filters servers by status.
            examples:
              - ACTIVE
        - in: query
          name: uuids
          required: false
          description: Filter servers by uuid.
          schema:
            description: Filter servers by uuid.
            example: d74c2bb9-cea7-4b23-a009-2f13518ae66d
            examples:
              - d74c2bb9-cea7-4b23-a009-2f13518ae66d
            items:
              type: string
            title: Uuids
            type: array
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ClusterInstanceServersList'
      x-codeSamples:
        - lang: Python
          source: >-
            import os

            from gcore import Gcore


            client = Gcore(
                api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
            )

            gpu_virtual_cluster_server_list =
            client.cloud.gpu_virtual.clusters.servers.list(
                cluster_id="1aaaab48-10d0-46d9-80cc-85209284ceb4",
                project_id=1,
                region_id=7,
            )

            print(gpu_virtual_cluster_server_list.count)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/G-Core/gcore-go\"\n\t\"github.com/G-Core/gcore-go/cloud\"\n\t\"github.com/G-Core/gcore-go/option\"\n)\n\nfunc main() {\n\tclient := gcore.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\tgpuVirtualClusterServerList, err := client.Cloud.GPUVirtual.Clusters.Servers.List(\n\t\tcontext.TODO(),\n\t\t\"1aaaab48-10d0-46d9-80cc-85209284ceb4\",\n\t\tcloud.GPUVirtualClusterServerListParams{\n\t\t\tProjectID: gcore.Int(1),\n\t\t\tRegionID:  gcore.Int(7),\n\t\t},\n\t)\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", gpuVirtualClusterServerList.Count)\n}\n"
components:
  schemas:
    GroupOrdering:
      enum:
        - created_at.asc
        - created_at.desc
        - status.asc
        - status.desc
      title: GroupOrdering
      type: string
    InstanceStatusQuery:
      enum:
        - ACTIVE
        - BUILD
        - ERROR
        - HARD_REBOOT
        - MIGRATING
        - PAUSED
        - REBOOT
        - REBUILD
        - RESIZE
        - REVERT_RESIZE
        - SHELVED
        - SHELVED_OFFLOADED
        - SHUTOFF
        - SOFT_DELETED
        - SUSPENDED
        - VERIFY_RESIZE
      title: InstanceStatusQuery
      type: string
    ClusterInstanceServersList:
      properties:
        count:
          description: Number of objects
          example: 1
          examples:
            - 1
          minimum: 0
          title: Count
          type: integer
        results:
          description: Objects
          items:
            $ref: '#/components/schemas/ClusterInstanceServer'
          title: Results
          type: array
      required:
        - count
        - results
      title: ClusterInstanceServersList
      type: object
    ClusterInstanceServer:
      properties:
        created_at:
          description: Server creation date and time
          example: '2025-03-17T13:22:23Z'
          examples:
            - '2025-03-17T13:22:23Z'
          format: date-time
          title: Created At
          type: string
        flavor:
          description: Unique flavor identifier
          example: g3-ai-64-384-3000-l40s-48-2
          examples:
            - g3-ai-64-384-3000-l40s-48-2
          title: Flavor
          type: string
        has_pending_changes:
          description: True if there are pending (not yet applied) server settings changes
          example: false
          examples:
            - false
          title: Has Pending Changes
          type: boolean
        id:
          description: Server unique identifier
          example: b6e58490-58d3-451c-bb77-4178157c98b2
          examples:
            - b6e58490-58d3-451c-bb77-4178157c98b2
          format: uuid4
          title: Id
          type: string
        image_id:
          anyOf:
            - format: uuid4
              type: string
            - type: 'null'
          description: Server's image UUID
          examples:
            - ded40aad-505c-463b-aa59-8f5f455d1b6f
          title: Image Id
        ip_addresses:
          description: List of IP addresses
          example:
            - 192.168.1.1
          examples:
            - - 192.168.1.1
          items:
            type: string
          title: Ip Addresses
          type: array
        name:
          description: Server's name generated using cluster's name
          example: my-server-e2241889
          examples:
            - my-server-e2241889
          title: Name
          type: string
        security_groups:
          description: Security groups
          example:
            - id: ae74714c-c380-48b4-87f8-758d656cdad6
              name: default
          examples:
            - - id: ae74714c-c380-48b4-87f8-758d656cdad6
                name: default
          items:
            $ref: '#/components/schemas/GroupSecurityGroupSerializer'
          title: Security Groups
          type: array
        ssh_key_name:
          anyOf:
            - type: string
            - type: 'null'
          description: SSH key pair assigned to the server
          examples:
            - ded40aad-505c-463b-aa59-8f5f455d1b6f
          title: Ssh Key Name
        status:
          $ref: '#/components/schemas/InstanceStatus'
          description: Current server status
          examples:
            - ACTIVE
        tags:
          description: User defined tags
          example:
            - key: task_id
              read_only: true
              value: d74c2bb9-cea7-4b23-a009-2f13518ae66d
          examples:
            - - key: task_id
                read_only: true
                value: d74c2bb9-cea7-4b23-a009-2f13518ae66d
          items:
            $ref: '#/components/schemas/TagSerializer'
          title: Tags
          type: array
        task_id:
          anyOf:
            - format: uuid4
              type: string
            - type: 'null'
          description: Identifier of the task currently modifying the GPU cluster
          examples:
            - ded40aad-505c-463b-aa59-8f5f455d1b6f
          title: Task Id
        updated_at:
          description: Server update date and time
          example: '2025-03-17T13:22:23Z'
          examples:
            - '2025-03-17T13:22:23Z'
          format: date-time
          title: Updated At
          type: string
      required:
        - id
        - image_id
        - task_id
        - flavor
        - ssh_key_name
        - name
        - status
        - ip_addresses
        - tags
        - created_at
        - updated_at
        - security_groups
        - has_pending_changes
      title: ClusterInstanceServer
      type: object
    GroupSecurityGroupSerializer:
      properties:
        id:
          description: Security group ID
          example: ae74714c-c380-48b4-87f8-758d656cdad6
          examples:
            - ae74714c-c380-48b4-87f8-758d656cdad6
          title: Id
          type: string
        name:
          description: Security group name
          example: default
          examples:
            - default
          title: Name
          type: string
      required:
        - id
        - name
      title: GroupSecurityGroupSerializer
      type: object
    InstanceStatus:
      enum:
        - ACTIVE
        - BUILD
        - DELETED
        - ERROR
        - HARD_REBOOT
        - MIGRATING
        - PASSWORD
        - PAUSED
        - REBOOT
        - REBUILD
        - RESCUE
        - RESIZE
        - REVERT_RESIZE
        - SHELVED
        - SHELVED_OFFLOADED
        - SHUTOFF
        - SOFT_DELETED
        - SUSPENDED
        - UNKNOWN
        - VERIFY_RESIZE
      title: InstanceStatus
      type: string
    TagSerializer:
      description: >-
        A tag is a key-value pair that can be associated with a resource,

        enabling efficient filtering and grouping for better organization and
        management.

        Some tags are read-only and cannot be modified by the user.

        Tags are also integrated with cost reports, allowing cost data to be
        filtered based on tag keys or values.
      properties:
        key:
          description: >-
            Tag key. Maximum 255 characters. Cannot contain spaces, tabs,
            newlines, empty string or '=' character.
          example: my-tag
          examples:
            - my-tag
          title: Key
          type: string
        read_only:
          description: If true, the tag is read-only and cannot be modified by the user
          example: false
          examples:
            - false
          title: Read Only
          type: boolean
        value:
          description: >-
            Tag value. Maximum 255 characters. Cannot contain spaces, tabs,
            newlines, empty string or '=' character.
          example: my-tag-value
          examples:
            - my-tag-value
          title: Value
          type: string
      required:
        - key
        - value
        - read_only
      title: TagSerializer
      type: object
  securitySchemes:
    APIKey:
      description: >-
        API key for authentication. Make sure to include the word `apikey`,
        followed by a single space and then your token.

        Example: `apikey 1234$abcdef`
      type: apiKey
      in: header
      name: Authorization

````